/************************************************************
*   Mega8 -   				*
* (c) 2011                              	*
* :                                   	*
*															*
*   									*
************************************************************/
/** @file chk_cmd.c
  * @brief      chk_cmd.c
  * @defgroup group1  
*/


#include "includes.h"

/******************************************************************************/
/*                                                                  */
/******************************************************************************/
/**     .*/
volatile unsigned char cmd_head_ptr=0;

/**     .*/
volatile unsigned char cmd_head_ptr_ovrf=0;

/**     .*/
volatile unsigned char cmd_tall_ptr=0;

/**     .*/
volatile unsigned char cmd_tall_ptr_ovrf=0;

/**  .      
 *    */
volatile unsigned char cmd_buff[cmd_buffer_upper_limit];

/**  .       */
volatile unsigned int  arg_buff[cmd_buffer_upper_limit];

/**      250 .*/
unsigned int main_cnt = 0;

/**      1.*/
unsigned int timer_1ms=1;

/**      5.*/
unsigned int timer_5ms = (5000/MAIN_SYSTEM_CLOCK);

/**      25.*/
unsigned int timer_10ms = (10000/MAIN_SYSTEM_CLOCK);

/**      25.*/
unsigned int timer_25ms=1;

/**      100.*/
unsigned int timer_100ms = (100000/MAIN_SYSTEM_CLOCK);

/**      1.*/
unsigned int timer_1sec = (1000000/MAIN_SYSTEM_CLOCK);

unsigned int timer_3sec=(3000000/MAIN_SYSTEM_CLOCK);

/******************************************************************************/
/*                                                                     */
/******************************************************************************/

/** @brief      .
 *             .  
 *         ,    cmd_buff[].
 *  @param  num_cmd -                  
 *  @param  arg     -                
 *  @return 
 *  @ingroup    TaskManager
*/
void Put_cmd_in_buff (unsigned char num_cmd, unsigned int arg)
{
    unsigned char sreg_tmp = __save_interrupt(); // SREG
    
    __disable_interrupt();    //  

    if (cmd_tall_ptr      == cmd_head_ptr &&    //    
        cmd_tall_ptr_ovrf != cmd_head_ptr_ovrf)
    {
        __restore_interrupt(sreg_tmp); //  
        return;
    }
	
    cmd_buff[cmd_tall_ptr] = num_cmd;	//   
    arg_buff[cmd_tall_ptr] = arg;       // 
    cmd_tall_ptr++;                     // 
	
    if (cmd_tall_ptr >= cmd_buffer_upper_limit)//   
    {
        cmd_tall_ptr  = 0;
        cmd_tall_ptr_ovrf = ~cmd_tall_ptr_ovrf;
    }
    __restore_interrupt(sreg_tmp); //  
}

/** @brief   () .
 *           .
 *                .
 *               
 *      .
 *  @param                  
 *  @return 
 *  @ingroup    TaskManager
 */
void Chk_cmd (void)
{
    if (cmd_head_ptr      != cmd_tall_ptr ||
        cmd_head_ptr_ovrf != cmd_tall_ptr_ovrf)
    {
        switch (cmd_buff[cmd_head_ptr]) // 
        {
            case SYSTEM_CLOCK: //   -    1000 
            
                main_cnt++;
//                
//                Put_cmd_in_buff(ONE_MILLISECOND,0); //  ~1                 
//                
//                if (main_cnt == timer_5ms)
                {
//        	        timer_5ms = main_cnt + (5000/MAIN_SYSTEM_CLOCK);
                    Put_cmd_in_buff(FIVE_MILLISECOND,0); //  ~5                     
                    
                    if (main_cnt == timer_10ms)
                    {
            	        timer_10ms = main_cnt + (20000/MAIN_SYSTEM_CLOCK);                                                                    
                        Put_cmd_in_buff(TEN_MILLISECOND,0); //  ~10 

                        if (main_cnt == timer_100ms)
                        {
                	        timer_100ms = main_cnt + (100000/MAIN_SYSTEM_CLOCK);                                                                    
                            Put_cmd_in_buff(STO_MILLISECOND,0); //  ~100 

                            if (main_cnt == timer_1sec)
                            {
                                timer_1sec = main_cnt + (1000000/MAIN_SYSTEM_CLOCK);                                                                    
                                Put_cmd_in_buff(ONE_SECOND,0); //  ~1 
                                
                                if (main_cnt == timer_3sec)
                                {
                                    timer_3sec = main_cnt + (3000000/MAIN_SYSTEM_CLOCK);                                                                    
                                    Put_cmd_in_buff(THREE_SECOND,0); //  ~3 
                                }                                
                            }
                        }                            
                    }                
                }                    
            break;
				
            case ONE_MILLISECOND: //,      1 C
         
            break;
            
            case FIVE_MILLISECOND:

				
				/*        */
				if (uart.state == RECIEVER) {
                   UartTimer ();
                }            				
            break;
            
            case TEN_MILLISECOND: //,      10 C
				/*      */
				GenerateFirstFront();							
            break;

            case STO_MILLISECOND: //,      100 C

            break;                        
            
            case ONE_SECOND: //,      1 C
//				printf_P ("1sec\n");
            break;
            
            case THREE_SECOND: //,      3 C

            break;

            case RX_COMPLETE:   //     -   
                RxCompete ();
            break;			
			
            
        }

        __disable_interrupt();    //     
        cmd_head_ptr++;                            // 
        if (cmd_head_ptr >= cmd_buffer_upper_limit)//   
        {
            cmd_head_ptr  = 0;                          // 
            cmd_head_ptr_ovrf = ~cmd_head_ptr_ovrf;//    
        }
        __enable_interrupt();    //            
    }

}

