/************************************************************
*   Mega8 -  , 	*
* (c) 2011                              	*
* :                                   	*
*															*
*   									*
************************************************************/

/** @file servo_drive.c
  * @brief      servo_drive.c
  */

#include "includes.h"

/******************************************************************************/
/*                                                      			  */
/******************************************************************************/


/******************************************************************************/
/*                                                                  */
/******************************************************************************/
/**     */
servo_t Servo[MAX_SERV];

/**      */
data_t Data;

/**     (ddr),    .*/  
volatile unsigned char *massiv_ddr[MAX_SERV]={&SERVO1_DDR};

/**     (port),   .*/  
volatile unsigned char *massiv_port[MAX_SERV]={&SERVO1_PORT};

/**     ,    .*/  
const unsigned char massiv_pin[MAX_SERV]={SERVO1_PIN};


/******************************************************************************/
/*                                                                     */
/******************************************************************************/

void Init_Servo (void)
{
    for (char i=0; i!=MAX_SERV; i++)
    {
        Servo[i].drv_ddr  = massiv_ddr[i];
        Servo[i].drv_port = massiv_port[i];
        Servo[i].drv_pin  = massiv_pin[i];        
		
		Servo[i].timer = TIME_1_5ms;
			
       *Servo[i].drv_ddr  |=  (1<<Servo[i].drv_pin); //    
       *Servo[i].drv_port &= ~(1<<Servo[i].drv_pin); //    0	
	}	   
	Data.servo_num = 0;								//      ,     
}

/** @brief        -   __|
 *			      .
 *			    5.    
 *			      .
 *  @param                  
 *  @return 
*/
void GenerateFirstFront (void)
{
	//  1   
	//     -   __|
	*Servo[Data.servo_num].drv_port |= (1<<Servo[Data.servo_num].drv_pin);	

	//  
	TIFR = 1<<OCF1A; 
	
	//    
	TIMSK |= 1<<OCIE1A;                			    
	
	//  
	TCNT1 = 0;
			
	//     
	OCR1A = Servo[Data.servo_num].timer;					
	
	TCCR1A = 0;
	
	//    1.
	TCCR1B = 1<<CS10;       
}

/** @brief     .     
 *            .
 *  @param                  
 *  @return 
 */
#pragma vector= TIMER1_COMPA_vect
__interrupt void  TIMER1_COMPA(void)
{
	//     -   |__
	//  0  
	*Servo[Data.servo_num].drv_port &= ~(1<<Servo[Data.servo_num].drv_pin);	
	
	//  
	TCCR1B = 0;       	
}