/** @file servo_drive.h
  * @brief      servo_drive.h
  */

/******************************************************************************/
/*                                                                 */
/******************************************************************************/
/** -  */
#define MAX_SERV            1

#define SERVO1_DDR DDRC   /**<       1. 
                           DDR   */  
#define SERVO2_DDR DDRD   /**<     2*/  
#define SERVO3_DDR DDRD   /**<     3*/  
#define SERVO4_DDR DDRD   /**<     4*/  
#define SERVO5_DDR DDRD   /**<     5*/  
#define SERVO6_DDR DDRD   /**<     6*/  


#define SERVO1_PORT PORTC   /**<     1
                             PORT   */  
#define SERVO2_PORT PORTD   /**<     2*/    
#define SERVO3_PORT PORTD   /**<     3*/    
#define SERVO4_PORT PORTD   /**<     4*/    
#define SERVO5_PORT PORTD   /**<     5*/    
#define SERVO6_PORT PORTD   /**<     6*/    


#define SERVO1_PIN 1   /**<    ,   1.
                            0  7*/  
#define SERVO2_PIN 1   /**<    ,   2*/    
#define SERVO3_PIN 2   /**<    ,   3*/    
#define SERVO4_PIN 3   /**<    ,   4*/  
#define SERVO5_PIN 4   /**<    ,   5*/  
#define SERVO6_PIN 5   /**<    ,   6*/  


/**       */
#define TIME_ONE_TAKT	(float)(1/(CPU_OSC*1000))	

/**     20  */
#define TIME_20ms   (long int)(20/TIME_ONE_TAKT)      

/**     0.7  */
#define TIME_0_7ms  (int)(0.7/TIME_ONE_TAKT)

/**     2.3  */
#define TIME_2_3ms  (int)(2.3/TIME_ONE_TAKT)

/**     1.5  */
#define TIME_1_5ms  (int)(1.5/TIME_ONE_TAKT)

#define STEP		(int)((0.004/TIME_ONE_TAKT)*3)		/**	  */

/******************************************************************************/
/*                                                                  */
/******************************************************************************/

/**    
 *  @ingroup servo_group
 */
typedef struct
{
    unsigned int timer;       		  /**<    */
    volatile unsigned char *drv_ddr;  /**<     */            
    volatile unsigned char *drv_port; /**<       */        
    unsigned char drv_pin;            /**<    ,  .*/    	
} servo_t;


/**      
 *  @ingroup servo_group
 */
typedef struct
{
    unsigned char 	   servo_status;       		/**<      */
    unsigned char 	   servo_num;       		/**<    */	
	unsigned long int  sum_timer;       		/**<      20*/	
  	
} data_t;

extern servo_t Servo[];

/******************************************************************************/
/*                                                                     */
/******************************************************************************/
void Init_Servo (void);
void GenerateFirstFront (void);