/** @file uart.h
  * @brief      uart.h
  */

/******************************************************************************/
/*                                                                 */
/******************************************************************************/
/**     /*/
#define MAX_BUF_SIZE            30

/**   */
#define OWN_ADDRESS				1

/**   */
#define MASTER_ADDRESS			50

/**      */
#define SET_NEW_STATE				10	/**<      */	
#define SET_NEW_STATE_ANSWER		11  /**<    */

/**  */
#define TRANSMITER            0     /**< */
#define RECIEVER              1     /**< */
#define PREPARE_FOR_ANSWER    2     /**<   */
#define WAIT_NEXT_PACKET      3     /**<     */

/**        5*/
#define MAX_TIMEOUT      2
/******************************************************************************/
/*                                                                  */
/******************************************************************************/

/**    
 *  @ingroup uart
 */
typedef struct
{
   unsigned char rx_buf[MAX_BUF_SIZE];     /**<  */
   unsigned char tx_buf[MAX_BUF_SIZE];     /**<  */
   unsigned char rx_cnt;                   /**<   */
   unsigned char tx_cnt;                   /**<   */  
   unsigned char rx_tmr;                   /**<    */  
   unsigned char state;                    /**<  
                                 * 0-TRANSMITER,1-RECIEVER,2-PREPARE_FOR_ANSWER
                                 * 3-WAIT_NEXT_PACKET */  
}uart_t;


extern uart_t  uart;
/******************************************************************************/
/*                                                                     */
/******************************************************************************/
void UartTimer (void);
unsigned char CaclculateCRC (unsigned char *buf);
void RxCompete (void);
void UartInit (void);